
// WrapLoader3D.java
// Andrew Davison, April 2005, ad@fivedots.coe.psu.ac.th

/* Šachovnicový svět s načteným objektem, zpočátku 
   umístěným uprostřed.
*/

import javax.swing.*;
import java.awt.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.vp.*;

// import com.tornadolabs.j3dtree.*;    // pro zobrazení grafu scény



public class WrapLoader3D extends JPanel
// Uchovává 3D-canvas, na nemž se zobrazuje nactený obrázek
{
  private static final int PWIDTH = 512;   // velikost panelu
  private static final int PHEIGHT = 512; 

  private static final int BOUNDSIZE = 100;  // větší než virtuální svět
  private static final Point3d USERPOSN = new Point3d(0,5,10);
    // počáteční pozice uživatele


  private SimpleUniverse su;
  private BranchGroup sceneBG;
  private BoundingSphere bounds;      // pro uzly prostredí

  private TransformGroup objectTG;    // uzel typu TG, pod kterým vísí načtený objekt
  private PropManager propMan;        // řídí manipulaci s načteným objektem

  // private Java3dTree j3dTree;   // rám pro umístění stromového zobrazení



  public WrapLoader3D(String filename, boolean hasCoordsInfo)
  // zkonstruuje 3D-canvas
  {
    setLayout( new BorderLayout() );
    setOpaque( false );
    setPreferredSize( new Dimension(PWIDTH, PHEIGHT));

    // load the object (the prop) and optional placement info
    propMan = new PropManager(filename, hasCoordsInfo);

    GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
    Canvas3D canvas3D = new Canvas3D(config);
    add("Center", canvas3D);

    su = new SimpleUniverse(canvas3D);

    // j3dTree = new Java3dTree();   // vytvoř zobrazovací strom pro SG

    createSceneGraph(filename);
    initUserPosition();        // nastav stanoviště pozorovatele
    orbitControls(canvas3D);   // ovládací prvky pro pohyb tohoto stanoviště

    su.addBranchGraph( sceneBG );

	// j3dTree.updateNodes( su );    // sestav okno pro zobrazení stromu

  } // konec metody: WrapLoader3D()


  private void createSceneGraph(String filename) 
  // inicializuje scénu
  { 
    sceneBG = new BranchGroup();
    bounds = new BoundingSphere(new Point3d(0,0,0), BOUNDSIZE); 

    lightScene();         // přidej světla
    addBackground();      // přidej oblohu
    sceneBG.addChild( new CheckerFloor().getBG() );  // přidej podlahu
    
    sceneBG.addChild( propMan.getTG() );    
                    // přidej načtený objekt do scény

	// j3dTree.recursiveApplyCapability( sceneBG );   // nastav bity oprávnění pro stromové zobrazení

    sceneBG.compile();   // zafixuj scénu
  } // konec metody: createScene()


  private void lightScene()
  // Jedno ambientní, 2 směrová světla
  {
    Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

    // priprav ambientní svetlo
    AmbientLight ambientLightNode = new AmbientLight(white);
    ambientLightNode.setInfluencingBounds(bounds);
    sceneBG.addChild(ambientLightNode);

    // priprav smerová svetla
    Vector3f light1Direction  = new Vector3f(-1.0f, -1.0f, -1.0f);
       // vlevo, dolů, dozadu 
    Vector3f light2Direction  = new Vector3f(1.0f, -1.0f, 1.0f);
       // vpravo, dolu, dopredu

    DirectionalLight light1 = 
            new DirectionalLight(white, light1Direction);
    light1.setInfluencingBounds(bounds);
    sceneBG.addChild(light1);

    DirectionalLight light2 = 
        new DirectionalLight(white, light2Direction);
    light2.setInfluencingBounds(bounds);
    sceneBG.addChild(light2);
  }  // konec metody: lightScene()



  private void addBackground()
  // modrá obhloha
  { Background back = new Background();
    back.setApplicationBounds( bounds );
    back.setColor(0.17f, 0.65f, 0.92f);    // barva oblohy
    sceneBG.addChild( back );
  }  // konec metody: addBackground()


  private void orbitControls(Canvas3D c)
  /* Třída OrbitBehaviour umožňuje uživateli otáčet, přibližovat a oddalovat scénu. */
  { OrbitBehavior orbit = 
		new OrbitBehavior(c, OrbitBehavior.REVERSE_ALL);
    orbit.setSchedulingBounds(bounds);
    ViewingPlatform vp = su.getViewingPlatform();
    vp.setViewPlatformBehavior(orbit);	    
  }  // konec metody: orbitControls()



  private void initUserPosition()
  // Pomocí metody lookAt() nastaví počáteční výhled uživatele
  {
    ViewingPlatform vp = su.getViewingPlatform();
    TransformGroup steerTG = vp.getViewPlatformTransform();

    Transform3D t3d = new Transform3D();
    steerTG.getTransform(t3d);

    // argumenty jsou: pozice pozorovatele, kam se dívá, směr nahoru
    t3d.lookAt( USERPOSN, new Point3d(0,0,0), new Vector3d(0,1,0));
    t3d.invert();

    steerTG.setTransform(t3d);
  }  // konec metody: initUserPosition()



  // ---------------------- zpracování načteného objektu ---------------------------
  // Následující metody slouží GUI ve třídě Loader3D pro přístup k objektu typu PropManager

  public void movePos(int axis, int change)
  {  propMan.move(axis, change);  }

  public void rotate(int axis, int change)
  {  propMan.rotate(axis, change);  }

  public void scale(double d)
  {  propMan.scale(d);  }

  public Vector3d getLoc()
  {  return propMan.getLoc();  }

  public Point3d getRotations()
  {  return propMan.getRotations();  }

  public double getScale()
  {  return propMan.getScale();  }

  public void saveCoordFile()
  {  propMan.saveCoordFile();  }


} // konec třídy: WrapLoader3D